// -------------------------------------------
// Formal Specification Lecture 2   
// -------------------------------------------

method ArrayDemo()
{
  var a := new int[3];
  
  // Explicit assignment to initialise the array.
  a[0], a[1], a[2] := 1,2,3;
  
  assert a[1] == 2;
  
  // Very useful way of initialising/updating arrays
  // through parallel assignment. Note: not logical forall here!
  // Often useful to avoid loops.
  
  // For all i from 0 but less than a.Length, increment a[i] by 1. 
  forall(i | 0 <= i < a.Length)
  {
    a[i] := a[i] + 1;
  }
  
  assert a[0] == 2 && a[1] == 3 && a[2] == 4;

  // Asserting some stuff with quantifiers.

  // All entries are greater than 0.
  assert forall i :: 0 <= i < a.Length ==> a[i] > 0;

  // There exist an entry somewhere in a that is 3.
  assert exists j :: 0 <= j < a.Length && a[j] == 3;
}
