// -------------------------------------------
// DEMO: Formal Specification Lecture 2     
// -------------------------------------------

class MyClass{
  
  // An integer field.
  var myfield : int;

 
  // In Dafny, we must say what part of memory a method writes to.
  // modifies keyword is used. Initalisation methods typically modifies
  // "this" object, i.e. all its fields.

  method Init(x : int)
  modifies this;
  requires x > 0;
  ensures myfield == x;
  {
    myfield := x;
  }
  
  method ManyReturns(x : int) returns (big: int, small : int)
  requires this.myfield >= 0;
  ensures big >= small;
  ensures big == x + this.myfield;
  {
    big := x + myfield;
    small := x - myfield;
  }
  method Demo(){
    var myObj := new MyClass.Init(5);
    assert myObj.myfield == 5;
   
    var y, z := myObj.ManyReturns(10); 
    assert y >= z;
    
    y := y+1;
    assert y == 16;

  }  
}
